import express,{Router, Request, Response} from 'express';
import {Project} from '../models/Project';
import {myDataSource} from '../app-data-source';

const router:Router = express.Router();
const dataSource = myDataSource;


router.get('/',async (req:Request, res:Response): Promise<Response>=> {
    const projects:Project[] = await dataSource.manager.find(Project)
    return res.send({projects})
})

router.get("/:project_id",async (req:Request, res:Response): Promise<Response> => {
    const project : Project|null= await dataSource.manager.findOneBy(Project, {
        id: req.params.project_id
    })
    if (!project) return res.status(404).send({Message:'no info in the base'})
    return res.send({project})
})

router.post('/', async (req:Request, res:Response): Promise<Response> => {
    if (!req.body) return res.status(400).send({Message:'problem in incoming req.body'})
    const {title, dateDue,department, admin,workers,tasks}= req.body
    const project : Project= new Project()
    project.title = title;
    project.dateDue = dateDue || null;
    project.department = department|| null;
    project.workers = workers|| null;
    project.tasks = tasks || null;
    project.admin = admin|| null;
    await project.save()
    return res.send({project})
})

export default router;
